require "elasticsearch_env_config/version"

class ElasticsearchEnvConfig
  class Error < StandardError; end

  def initialize(env: ENV)
    @env = env
  end

  def to_h
    {}.tap do |config|
      if @env.include?("ELASTICSEARCH_HOSTS")
        config[:hosts] = @env.fetch("ELASTICSEARCH_HOSTS").split(/[,\s]+/)
        config[:index] = @env.fetch("ELASTICSEARCH_INDEX") { raise Error, "missing environment variable ELASTICSEARCH_INDEX" }

        %i[ user password date_pattern host application ].each do |key|
          v = @env["ELASTICSEARCH_#{key.upcase}"]
          config[key] = v if v
        end
      end
    end
  end

end
